<template>
  <div class="account-information__right">
    <!-- Thông tin tài khoản  -->
    <div class="items_dropdown mb40">
      <h2 class="title_cate active">
        <span>Thông tin tài khoản</span>
        <svg class="icon-svg">
          <use xlink:href="/images/icons/icon.svg#arrow-left" />
        </svg>
      </h2>
      <div class="border-warp padding_24">
        <div class="form-default min-width">
          <div class="row">
            <div class="col-md-6 form-group">
              <div class="choose-ava">
                <div class="ava">
                  <img
                    :src="resizeImage(baseImageUrl + info.avatar, 100, 100)"
                  />
                </div>
                <label class="choose">
                  <input
                    type="file"
                    name="avatar"
                    @change.prevent="changeAvatar"
                  />
                  <span>Thay ảnh đại diện</span>
                </label>
              </div>
            </div>
            <div class="col-md-6 form-group">
              <label class="block">Số điện thoại</label>
              <div class="input-wrap">
                <input
                  id
                  type="text"
                  class="form-control"
                  :value="info.phone"
                  disabled
                />
              </div>
            </div>
            <div class="col-md-6 form-group">
              <label class="block">Họ và tên</label>
              <div class="input-wrap">
                <input v-model="info.name" type="text" class="form-control" />
              </div>
            </div>
            <div class="col-md-6 form-group">
              <label class="block">Email</label>
              <div class="input-wrap">
                <input v-model="info.email" type="email" class="form-control" />
              </div>
            </div>
            <span v-if="Object.keys(info_errors).length" class="error">
              {{ info_errors[Object.keys(info_errors)[0]][0] }}
            </span>
          </div>
          <div class="mt30">
            <a
              class="btn-default color-white"
              href="javascript:;"
              @click.prevent="changeInfo"
            >
              Cập nhật
            </a>
          </div>
        </div>
      </div>
    </div>
    <!-- Địa chỉ giao hàng -->
    <div class="items_dropdown mb40">
      <h2 class="title_cate">
        <span>Địa chỉ giao hàng</span>
        <svg class="icon-svg">
          <use xlink:href="/images/icons/icon.svg#arrow-left" />
        </svg>
      </h2>
      <div class="border-warp padding_24">
        <div class="form-default min-width">
          <div class="mb8">
            <div class="row">
              <div class="col-md-6 form-group">
                <div class="input-wrap">
                  <input
                    v-model="address.tinh_thanhpho"
                    type="text"
                    class="form-control"
                    placeholder="Tỉnh/Thành phố"
                  />
                </div>
              </div>
              <div class="col-md-6 form-group">
                <div class="input-wrap">
                  <input
                    v-model="address.quan_huyen"
                    type="text"
                    class="form-control"
                    placeholder="Quận/Huyện"
                  />
                </div>
              </div>
              <div class="col-md-6 form-group">
                <div class="input-wrap">
                  <input
                    v-model="address.phuong_xa"
                    type="text"
                    class="form-control"
                    placeholder="Phường/Xã"
                  />
                </div>
              </div>
              <div class="col-md-6 form-group">
                <div class="input-wrap">
                  <input
                    v-model="address.so_nha"
                    type="text"
                    class="form-control"
                    placeholder="Số nhà"
                  />
                </div>
              </div>
              <span v-if="Object.keys(address_errors).length" class="error">
                {{ address_errors[Object.keys(address_errors)[0]][0] }}
              </span>
            </div>
          </div>
          <div class="mt24">
            <a
              class="btn-default color-white"
              href="javascript:;"
              @click.prevent="changeAddress"
            >
              Cập nhật
            </a>
          </div>
        </div>
      </div>
    </div>
    <!-- Thay đổi mật khẩu -->
    <div class="items_dropdown mb40">
      <h2 class="title_cate">
        <span>Thay đổi mật khẩu</span>
        <svg class="icon-svg">
          <use xlink:href="/images/icons/icon.svg#arrow-left" />
        </svg>
      </h2>
      <div class="border-warp padding_24">
        <div class="form-default min-width">
          <div class="row mb30">
            <div class="col-md-6 form-group">
              <label class="block">Nhập mật khẩu hiện tại</label>
              <div class="input-wrap">
                <input
                  id
                  v-model="password.cur_pass"
                  type="password"
                  class="form-control"
                  placeholder="Nhập mật khẩu hiện tại"
                />
              </div>
            </div>
          </div>
          <div class="row">
            <div class="col-md-6 form-group">
              <label class="block">Mật khẩu mới</label>
              <div class="input-wrap">
                <input
                  v-model="password.new_pass"
                  type="password"
                  class="form-control"
                />
              </div>
            </div>
            <div class="col-md-6 form-group">
              <label class="block">Nhập lại mật khẩu mới</label>
              <div class="input-wrap">
                <input
                  v-model="password.new_pass_con"
                  type="password"
                  class="form-control"
                />
              </div>
            </div>
            <span v-if="Object.keys(password_errors).length" class="error">
              {{ password_errors[Object.keys(password_errors)[0]][0] }}
            </span>
          </div>
          <div class="mt30">
            <a
              class="btn-default color-white"
              href="javascript:;"
              @click.prevent="changePassword"
            >
              Cập nhật
            </a>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import Helper from '../../assets/config'

export default {
  name: 'UserRight',
  fetch() {
    this.takeAuthUser()
  },
  data() {
    return {
      info: {
        phone: '',
        avatar: '',
        name: '',
        email: '',
      },
      address: {
        tinh_thanhpho: '',
        quan_huyen: '',
        phuong_xa: '',
        so_nha: '',
      },
      password: {
        cur_pass: '',
        new_pass: '',
        new_pass_con: '',
      },
      info_errors: {},
      address_errors: {},
      password_errors: {},
    }
  },
  computed: {
    baseImageUrl() {
      return Helper.baseImageUrl
    },
  },
  mounted() {
    // $('.toggle').click(function () {
    //   if ($(this).hasClass('active')) {
    //     $(this).removeClass('active')
    //   } else {
    //     $(this).addClass('active')
    //   }
    // })
    // $('body').addClass('page-step')
  },
  methods: {
    takeAuthUser() {
      const user = this.$auth.user
      this.info.phone = user.phone
      this.info.avatar = user.avatar
      this.info.name = user.name
      this.info.email = user.email
      this.address.tinh_thanhpho = user.tinh_thanhpho
      this.address.quan_huyen = user.quan_huyen
      this.address.phuong_xa = user.phuong_xa
      this.address.so_nha = user.so_nha
    },
    changeInfo() {
      this.$axios.$post('/account/info/change', this.info).then((data) => {
        if (data.status) {
          this.$auth.fetchUser().then((data) => {
            this.takeAuthUser()
          })
        } else {
          this.info_errors = data.data
        }
      })
    },
    changeAddress() {
      this.$axios
        .$post('/account/address/change', this.address)
        .then((data) => {
          if (data.status) {
            this.$auth.fetchUser().then((data) => {
              this.takeAuthUser()
            })
          } else {
            this.address_errors = data.data
          }
        })
    },
    changePassword() {
      this.password_errors = {}
      this.$axios
        .$post('/account/password/change', this.password)
        .then((data) => {
          if (data.status) {
            this.$auth.fetchUser().then((data) => {
              this.takeAuthUser()
            })
          } else {
            this.password_errors = data.data
          }
        })
    },
    changeAvatar(e) {
      // eslint-disable-next-line camelcase
      const image_upload = new FormData()
      const images = e.target.files
      image_upload.append('file', images[0])

      this.$axios.$post('/account/avatar/change', image_upload).then((data) => {
        this.info.avatar = data.data
        e.target.value = null
      })
    },
    resizeImage(url, width, height) {
      return Helper.resizeImage(url, width, height)
    },
  },
}
</script>
